(function() {
  var $, _, domain, http, https,
    slice = [].slice,
    indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  _ = require('lodash');

  module.exports = $ = {
    version: '0.3.0',
    startTime: _.now()
  };

  $.env = (process.env.NODE_ENV || 'production').toLowerCase();

  $.debug = $.env === 'development' ? true : false;

  domain = require('domain');

  process.on('uncaughtException', function(err) {
    $.info('fatal', err);
    return $.log(err.stack);
  });

  $["try"] = function() {
    var p, param, res;
    param = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    p = param;
    res = {
      _domain: domain.create()
    };
    res["try"] = function(fn) {
      $.next(function() {
        return res._domain.run(fn);
      });
      return res;
    };
    res["catch"] = function(fn) {
      res._catch = fn;
      return res;
    };
    res._domain.on('error', function(err) {
      $.info('error', err);
      return typeof res._catch === "function" ? res._catch(err) : void 0;
    });
    if (($.type(p[0])) === 'function') {
      res["try"](p[0]);
    }
    if (($.type(p[1])) === 'function') {
      res["catch"](p[1]);
    }
    return res;
  };

  $.extend = _.extend;

  $.param = (require('querystring')).stringify;

  $.trim = _.trim;

  $.now = _.now;

  $.type = function(param) {
    var p, t;
    p = param;
    t = typeof p;
    switch (t) {
      case 'object':
        if (p) {
          if (toString.call(p) === '[object Array]') {
            return 'array';
          }
          if (p.fill) {
            return 'buffer';
          }
          return 'object';
        } else {
          if (p === null) {
            return 'null';
          }
          return 'undefined';
        }
        break;
      case 'number':
        if (p !== +p) {
          return 'NaN';
        }
        return t;
      default:
        return t;
    }
  };

  $.Callbacks = function() {
    var list, res;
    res = {
      _status: {
        fired: false
      },
      _list: []
    };
    list = res._list;
    res.add = function() {
      var fn, j, len1, param;
      param = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      for (j = 0, len1 = param.length; j < len1; j++) {
        fn = param[j];
        list.push(fn);
      }
      return res;
    };
    res.remove = function(fn) {
      var f, i, j, len1;
      for (i = j = 0, len1 = list.length; j < len1; i = ++j) {
        f = list[i];
        if (!(f === fn)) {
          continue;
        }
        list.splice(i, 1);
        break;
      }
      return res;
    };
    res.has = function(fn) {
      return indexOf.call(list, fn) >= 0;
    };
    res.empty = function() {
      list = [];
      return res;
    };
    res.fire = function() {
      var fn, j, len1, param;
      param = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      for (j = 0, len1 = list.length; j < len1; j++) {
        fn = list[j];
        if (typeof fn === "function") {
          fn.apply(null, param);
        }
      }
      res._status.fired = true;
      return res;
    };
    res.fired = function() {
      return res._status.fired;
    };
    return res;
  };

  $.Deferred = function() {
    var list, res;
    res = {
      _list: {
        done: $.Callbacks(),
        fail: $.Callbacks()
      }
    };
    list = res._list;
    res.done = function(callback) {
      list.done.add(callback);
      return res;
    };
    res.fail = function(callback) {
      list.fail.add(callback);
      return res;
    };
    res.resolve = function() {
      var param, ref;
      param = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      (ref = list.done).fire.apply(ref, param);
      return res;
    };
    res.reject = function() {
      var param, ref;
      param = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      (ref = list.fail).fire.apply(ref, param);
      return res;
    };
    return res;
  };

  $.parseTime = function(param) {
    var trans;
    trans = function(t) {
      var dayAgo, dt, dtNow, hrAgo, hrMin, longAgo, longLongAgo, minAgo, secAgo, ts, tsDistance, tsNow;
      dt = new Date(t);
      ts = dt.getTime();
      dtNow = new Date();
      tsNow = dtNow.getTime();
      tsDistance = tsNow - ts;
      hrMin = dt.getHours() + '时' + (dt.getMinutes() < 10 ? '0' : '') + dt.getMinutes() + '分';
      longAgo = (dt.getMonth() + 1) + '月' + dt.getDate() + '日(星期' + ['日', '一', '二', '三', '四', '五', '六'][dt.getDay()] + ') ' + hrMin;
      longLongAgo = dt.getFullYear() + '年' + longAgo;
      if (tsDistance < 0) {
        return '刚刚';
      }
      if ((tsDistance / 1000 / 60 / 60 / 24 / 365) | 0) {
        return longLongAgo;
      }
      if ((dayAgo = tsDistance / 1000 / 60 / 60 / 24) > 3) {
        if (dt.getFullYear() !== dtNow.getFullYear()) {
          return longLongAgo;
        }
        return longAgo;
      }
      if ((dayAgo = (dtNow.getDay() - dt.getDay() + 7) % 7) > 2) {
        return longAgo;
      }
      if (dayAgo > 1) {
        return '前天 ' + hrMin;
      }
      if ((hrAgo = tsDistance / 1000 / 60 / 60) > 12) {
        return (dt.getDay() !== dtNow.getDay() ? '昨天 ' : '今天 ') + hrMin;
      }
      if (hrAgo = (tsDistance / 1000 / 60 / 60 % 60) | 0) {
        return hrAgo + '小时前';
      }
      if (minAgo = (tsDistance / 1000 / 60 % 60) | 0) {
        return minAgo + '分钟前';
      }
      if ((secAgo = (tsDistance / 1000 % 60) | 0) > 30) {
        return secAgo + '秒前';
      }
      return '刚刚';
    };
    return trans($.timeStamp(param));
  };

  $.parseString = function(data) {
    var d, e, error;
    switch ($.type(d = data)) {
      case 'string':
        return d;
      case 'number':
        return d.toString();
      case 'array':
        return (JSON.stringify({
          _obj: d
        })).replace(/\{(.*)\}/, '$1').replace(/"_obj":/, '');
      case 'object':
        return JSON.stringify(d);
      case 'boolean':
        return d.toString();
      case 'undefined':
        return 'undefined';
      case 'null':
        return 'null';
      default:
        try {
          return d.toString();
        } catch (error) {
          e = error;
          return '';
        }
    }
  };

  $.parsePts = function(number) {
    var n;
    if ((n = (number || 0) | 0) >= 1e5) {
      return (((n * 0.001) | 0) / 10) + '万';
    } else {
      return n.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,');
    }
  };

  $.parseJson = function(data) {
    var d, fn;
    d = data;
    fn = function(p) {
      var e, error, res;
      try {
        res = eval("(" + p + ")");
        switch ($.type(res)) {
          case 'object':
          case 'array':
            return res;
          default:
            return null;
        }
      } catch (error) {
        e = error;
        return null;
      }
    };
    switch ($.type(d)) {
      case 'string':
        return fn(d);
      case 'object':
        return d;
      default:
        return null;
    }
  };

  http = require('http');

  https = require('https');

  $.get = function() {
    var _http, def, p, param, req, url;
    param = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    p = param;
    _http = ~p[0].search('https://') ? https : http;
    url = p[0] + (p[1] ? '?' + $.param(p[1]) : '');
    req = _http.get(url, function(res) {
      var data, len;
      data = [];
      len = 0;
      return res.on('data', function(chunk) {
        data.push(chunk);
        return len += chunk.length;
      }).on('end', function() {
        data = Buffer.concat(data, len).toString();
        return def.resolve(data);
      });
    });
    req.on('error', function(err) {
      return def.reject(err);
    });
    return def = $.Deferred();
  };

  $.post = function() {
    var _http, buffer, def, href, p, param, req;
    param = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    p = param;
    _http = ~p[0].search('https://') ? https : http;
    href = (function() {
      var _host, _href, _port, _type, arr, i;
      arr = p[0].split('//');
      _type = ~arr[0].search('https') ? 'https' || 'http' : void 0;
      i = arr[1].indexOf('/');
      if (i < 0) {
        i = arr[1].length;
      }
      _host = arr[1].slice(0, i);
      _href = arr[1].slice(i) || '/';
      _host = _host.split(':');
      _port = _host[1] || 80;
      _host = _host[0];
      return [_type, _host, _href, _port];
    })();
    buffer = $.param(p[1]);
    req = _http.request({
      host: href[1],
      port: href[3],
      method: 'POST',
      path: href[2],
      headers: {
        'Content-Type': 'application/x-www-form-urlencoded'
      }
    }, function(res) {
      var data;
      data = '';
      return res.on('data', function(chunk) {
        data.push(chunk);
        return len += chunk.length;
      }).on('end', function() {
        data = Buffer.concat(data, len).toString();
        return def.resolve(data);
      });
    });
    req.write(buffer);
    req.end();
    req.on('error', function(err) {
      return def.reject(err);
    });
    return def = $.Deferred();
  };

  $.next = function() {
    var fn, param, ref, time;
    param = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    ref = !param[1] ? [0, param[0]] : param, time = ref[0], fn = ref[1];
    if (time) {
      setTimeout(fn, time);
      return;
    }
    return process.nextTick(fn);
  };

  $.log = console.log;

  $.info = function() {
    var a, arr, d, msg, param, ref, t, type;
    param = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    ref = !param[1] ? ['default', param[0]] : param, type = ref[0], msg = ref[1];
    d = new Date();
    t = ((function() {
      var j, len1, ref1, results;
      ref1 = [d.getHours(), d.getMinutes(), d.getSeconds()];
      results = [];
      for (j = 0, len1 = ref1.length; j < len1; j++) {
        a = ref1[j];
        results.push(a < 10 ? '0' + a : a);
      }
      return results;
    })()).join(':');
    arr = ['[' + t + ']'];
    if (type !== 'default') {
      arr.push('<' + type.toUpperCase() + '>');
    }
    arr.push(msg);
    $.log(arr.join(' '));
    return msg;
  };

  $.i = function(msg) {
    $.log(msg);
    return msg;
  };

  $.timeStamp = function(param) {
    var a, b, c, d, i, j, p;
    switch ($.type(p = param)) {
      case 'number':
        return p;
      case 'string':
        if (!~p.search(/[\s\.\-\/]/)) {
          return $.now();
        }
        if (~p.search(/\:/)) {
          a = p.split(' ');
          if (!~a[0].search(/\:/)) {
            b = a[0].replace(/[\-\/]/g, '.').split('.');
            c = a[1].split(':');
          } else {
            b = a[1].replace(/[\-\/]/g, '.').split('.');
            c = a[0].split(':');
          }
        } else {
          b = p.replace(/[\-\/]/g, '.').split('.');
          c = [0, 0, 0];
        }
        for (i = j = 0; j <= 2; i = ++j) {
          b[i] = parseInt(b[i]);
          c[i] = parseInt(c[i] || 0);
        }
        d = new Date();
        d.setFullYear(b[0], b[1] - 1, b[2]);
        d.setHours(c[0], c[1], c[2]);
        return parseInt(d.getTime() / 1e3) * 1e3;
      default:
        return $.now();
    }
  };

  $.rnd = function() {
    var p, r;
    p = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    r = Math.random();
    switch (p.length) {
      case 1:
        switch ($.type(p[0])) {
          case 'number':
            return (r * p[0]) | 0;
          case 'array':
            return p[0][(r * p[0].length) | 0];
        }
        break;
      case 2:
        return (p[0] + r * (p[1] - p[0])) | 0;
      default:
        return (r * 2) | 0;
    }
  };

  $.timeString = function(time) {
    var d, fn;
    d = time ? new Date(time) : new Date();
    fn = function(n) {
      if (n < 10) {
        return '0' + n;
      } else {
        return n;
      }
    };
    return [fn(d.getHours()), fn(d.getMinutes()), fn(d.getSeconds())].join(':');
  };

}).call(this);
